/*******************************************************************************
 * Copyright (c) 2005-2008 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Frderic Jouault
 *******************************************************************************/

//  This file has been generated using ANTLR 3.0.1

// $ANTLR 3.0.1 C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g 2008-07-01 14:11:59
package org.eclipse.gmt.tcs.injector;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class KM3_ANTLR3Lexer extends Lexer {
    public static final int LT=36;
    public static final int STAR=15;
    public static final int LSQUARE=14;
    public static final int POINT=30;
    public static final int ESC=23;
    public static final int LARROW=40;
    public static final int FLOAT=24;
    public static final int EXCL=25;
    public static final int EOF=-1;
    public static final int LPAREN=12;
    public static final int COLONS=26;
    public static final int RPAREN=13;
    public static final int NAME=4;
    public static final int SLASH=32;
    public static final int PLUS=33;
    public static final int PIPE=27;
    public static final int DIGIT=20;
    public static final int NL=18;
    public static final int EQ=34;
    public static final int COMMENT=41;
    public static final int NE=39;
    public static final int GE=37;
    public static final int SHARP=28;
    public static final int RARROW=31;
    public static final int T49=49;
    public static final int T48=48;
    public static final int LCURLY=7;
    public static final int INT=6;
    public static final int MINUS=17;
    public static final int RSQUARE=16;
    public static final int T43=43;
    public static final int Tokens=57;
    public static final int COMA=10;
    public static final int T42=42;
    public static final int SEMI=9;
    public static final int T47=47;
    public static final int T46=46;
    public static final int ALPHA=21;
    public static final int T45=45;
    public static final int T44=44;
    public static final int COLON=11;
    public static final int WS=19;
    public static final int T50=50;
    public static final int SNAME=22;
    public static final int RCURLY=8;
    public static final int GT=35;
    public static final int T52=52;
    public static final int T51=51;
    public static final int T54=54;
    public static final int T53=53;
    public static final int QMARK=29;
    public static final int T56=56;
    public static final int LE=38;
    public static final int T55=55;
    public static final int STRING=5;
    
    
    	private void newline() {}
    
    	public org.eclipse.gmt.tcs.injector.TCSRuntime ei = null;
    
    	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
    		ei.reportError((Exception)e);
    	}
    
    	public Token emit() {
    		org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken ret = null;
    
    		ret = new org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken(input, type, channel, tokenStartCharIndex, getCharIndex()-1);
    		ret.setLine(tokenStartLine);
    		ret.setText(text);
    	  	ret.setCharPositionInLine(tokenStartCharPositionInLine);
    		ret.setEndLine(getLine());
    		ret.setEndColumn(getCharPositionInLine());
    		emit(ret);
    
    		return ret;
    	}
    

    public KM3_ANTLR3Lexer() {;} 
    public KM3_ANTLR3Lexer(CharStream input) {
        super(input);
    }
    public String getGrammarFileName() { return "C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g"; }

    // $ANTLR start T42
    public final void mT42() throws RecognitionException {
        try {
            int _type = T42;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:29:5: ( 'package' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:29:7: 'package'
            {
            match("package"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T42

    // $ANTLR start T43
    public final void mT43() throws RecognitionException {
        try {
            int _type = T43;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:30:5: ( 'datatype' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:30:7: 'datatype'
            {
            match("datatype"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T43

    // $ANTLR start T44
    public final void mT44() throws RecognitionException {
        try {
            int _type = T44;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:31:5: ( 'abstract' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:31:7: 'abstract'
            {
            match("abstract"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T44

    // $ANTLR start T45
    public final void mT45() throws RecognitionException {
        try {
            int _type = T45;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:32:5: ( 'class' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:32:7: 'class'
            {
            match("class"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T45

    // $ANTLR start T46
    public final void mT46() throws RecognitionException {
        try {
            int _type = T46;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:33:5: ( 'extends' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:33:7: 'extends'
            {
            match("extends"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T46

    // $ANTLR start T47
    public final void mT47() throws RecognitionException {
        try {
            int _type = T47;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:34:5: ( 'reference' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:34:7: 'reference'
            {
            match("reference"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T47

    // $ANTLR start T48
    public final void mT48() throws RecognitionException {
        try {
            int _type = T48;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:35:5: ( 'container' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:35:7: 'container'
            {
            match("container"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T48

    // $ANTLR start T49
    public final void mT49() throws RecognitionException {
        try {
            int _type = T49;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:36:5: ( 'subsets' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:36:7: 'subsets'
            {
            match("subsets"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T49

    // $ANTLR start T50
    public final void mT50() throws RecognitionException {
        try {
            int _type = T50;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:37:5: ( 'oppositeOf' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:37:7: 'oppositeOf'
            {
            match("oppositeOf"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T50

    // $ANTLR start T51
    public final void mT51() throws RecognitionException {
        try {
            int _type = T51;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:38:5: ( 'attribute' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:38:7: 'attribute'
            {
            match("attribute"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T51

    // $ANTLR start T52
    public final void mT52() throws RecognitionException {
        try {
            int _type = T52;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:39:5: ( 'unique' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:39:7: 'unique'
            {
            match("unique"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T52

    // $ANTLR start T53
    public final void mT53() throws RecognitionException {
        try {
            int _type = T53;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:40:5: ( 'operation' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:40:7: 'operation'
            {
            match("operation"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T53

    // $ANTLR start T54
    public final void mT54() throws RecognitionException {
        try {
            int _type = T54;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:41:5: ( 'enumeration' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:41:7: 'enumeration'
            {
            match("enumeration"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T54

    // $ANTLR start T55
    public final void mT55() throws RecognitionException {
        try {
            int _type = T55;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:42:5: ( 'literal' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:42:7: 'literal'
            {
            match("literal"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T55

    // $ANTLR start T56
    public final void mT56() throws RecognitionException {
        try {
            int _type = T56;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:43:5: ( 'ordered' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:43:7: 'ordered'
            {
            match("ordered"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T56

    // $ANTLR start NL
    public final void mNL() throws RecognitionException {
        try {
            int _type = NL;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:241:2: ( ( '\\r' '\\n' | '\\n' '\\r' | '\\r' | '\\n' ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:241:4: ( '\\r' '\\n' | '\\n' '\\r' | '\\r' | '\\n' )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:241:4: ( '\\r' '\\n' | '\\n' '\\r' | '\\r' | '\\n' )
            int alt1=4;
            int LA1_0 = input.LA(1);

            if ( (LA1_0=='\r') ) {
                int LA1_1 = input.LA(2);

                if ( (LA1_1=='\n') ) {
                    alt1=1;
                }
                else {
                    alt1=3;}
            }
            else if ( (LA1_0=='\n') ) {
                int LA1_2 = input.LA(2);

                if ( (LA1_2=='\r') ) {
                    alt1=2;
                }
                else {
                    alt1=4;}
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("241:4: ( '\\r' '\\n' | '\\n' '\\r' | '\\r' | '\\n' )", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:241:6: '\\r' '\\n'
                    {
                    match('\r'); 
                    match('\n'); 

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:242:5: '\\n' '\\r'
                    {
                    match('\n'); 
                    match('\r'); 

                    }
                    break;
                case 3 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:243:5: '\\r'
                    {
                    match('\r'); 

                    }
                    break;
                case 4 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:244:5: '\\n'
                    {
                    match('\n'); 

                    }
                    break;

            }

            newline();

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end NL

    // $ANTLR start WS
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:250:2: ( ( ' ' | '\\t' ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:250:4: ( ' ' | '\\t' )
            {
            if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end WS

    // $ANTLR start DIGIT
    public final void mDIGIT() throws RecognitionException {
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:257:2: ( '0' .. '9' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:257:4: '0' .. '9'
            {
            matchRange('0','9'); 

            }

        }
        finally {
        }
    }
    // $ANTLR end DIGIT

    // $ANTLR start ALPHA
    public final void mALPHA() throws RecognitionException {
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:262:2: ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '\\u00C0' .. '\\u00D6' | '\\u00D8' .. '\\u00F6' | '\\u00F8' .. '\\u00FF' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z')||(input.LA(1)>='\u00C0' && input.LA(1)<='\u00D6')||(input.LA(1)>='\u00D8' && input.LA(1)<='\u00F6')||(input.LA(1)>='\u00F8' && input.LA(1)<='\u00FF') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

        }
        finally {
        }
    }
    // $ANTLR end ALPHA

    // $ANTLR start SNAME
    public final void mSNAME() throws RecognitionException {
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:276:2: ( ( ALPHA ) ( ALPHA | DIGIT )* )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:276:4: ( ALPHA ) ( ALPHA | DIGIT )*
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:276:4: ( ALPHA )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:276:5: ALPHA
            {
            mALPHA(); 

            }

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:276:12: ( ALPHA | DIGIT )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( ((LA2_0>='0' && LA2_0<='9')||(LA2_0>='A' && LA2_0<='Z')||LA2_0=='_'||(LA2_0>='a' && LA2_0<='z')||(LA2_0>='\u00C0' && LA2_0<='\u00D6')||(LA2_0>='\u00D8' && LA2_0<='\u00F6')||(LA2_0>='\u00F8' && LA2_0<='\u00FF')) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:
            	    {
            	    if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z')||(input.LA(1)>='\u00C0' && input.LA(1)<='\u00D6')||(input.LA(1)>='\u00D8' && input.LA(1)<='\u00F6')||(input.LA(1)>='\u00F8' && input.LA(1)<='\u00FF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }

        }
        finally {
        }
    }
    // $ANTLR end SNAME

    // $ANTLR start NAME
    public final void mNAME() throws RecognitionException {
        try {
            int _type = NAME;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:280:2: ( ( SNAME | '\"' ( ESC | '\\n' | ~ ( '\\\\' | '\\\"' | '\\n' ) )* '\"' ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:280:4: ( SNAME | '\"' ( ESC | '\\n' | ~ ( '\\\\' | '\\\"' | '\\n' ) )* '\"' )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:280:4: ( SNAME | '\"' ( ESC | '\\n' | ~ ( '\\\\' | '\\\"' | '\\n' ) )* '\"' )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( ((LA4_0>='A' && LA4_0<='Z')||LA4_0=='_'||(LA4_0>='a' && LA4_0<='z')||(LA4_0>='\u00C0' && LA4_0<='\u00D6')||(LA4_0>='\u00D8' && LA4_0<='\u00F6')||(LA4_0>='\u00F8' && LA4_0<='\u00FF')) ) {
                alt4=1;
            }
            else if ( (LA4_0=='\"') ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("280:4: ( SNAME | '\"' ( ESC | '\\n' | ~ ( '\\\\' | '\\\"' | '\\n' ) )* '\"' )", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:281:4: SNAME
                    {
                    mSNAME(); 

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:283:5: '\"' ( ESC | '\\n' | ~ ( '\\\\' | '\\\"' | '\\n' ) )* '\"'
                    {
                    match('\"'); 
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:284:4: ( ESC | '\\n' | ~ ( '\\\\' | '\\\"' | '\\n' ) )*
                    loop3:
                    do {
                        int alt3=4;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0=='\\') ) {
                            alt3=1;
                        }
                        else if ( (LA3_0=='\n') ) {
                            alt3=2;
                        }
                        else if ( ((LA3_0>='\u0000' && LA3_0<='\t')||(LA3_0>='\u000B' && LA3_0<='!')||(LA3_0>='#' && LA3_0<='[')||(LA3_0>=']' && LA3_0<='\uFFFE')) ) {
                            alt3=3;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:284:6: ESC
                    	    {
                    	    mESC(); 

                    	    }
                    	    break;
                    	case 2 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:285:6: '\\n'
                    	    {
                    	    match('\n'); 
                    	    newline();

                    	    }
                    	    break;
                    	case 3 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:286:6: ~ ( '\\\\' | '\\\"' | '\\n' )
                    	    {
                    	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='!')||(input.LA(1)>='#' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFE') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse =
                    	            new MismatchedSetException(null,input);
                    	        recover(mse);    throw mse;
                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    match('\"'); 
                    setText(ei.unescapeString(getText(), 1));

                    }
                    break;

            }


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end NAME

    // $ANTLR start INT
    public final void mINT() throws RecognitionException {
        try {
            int _type = INT;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:294:2: ( ( DIGIT )+ )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:294:4: ( DIGIT )+
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:294:4: ( DIGIT )+
            int cnt5=0;
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( ((LA5_0>='0' && LA5_0<='9')) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:294:5: DIGIT
            	    {
            	    mDIGIT(); 

            	    }
            	    break;

            	default :
            	    if ( cnt5 >= 1 ) break loop5;
                        EarlyExitException eee =
                            new EarlyExitException(5, input);
                        throw eee;
                }
                cnt5++;
            } while (true);


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end INT

    // $ANTLR start FLOAT
    public final void mFLOAT() throws RecognitionException {
        try {
            int _type = FLOAT;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:298:7: ( ( DIGIT )+ '.' ( DIGIT )* )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:298:9: ( DIGIT )+ '.' ( DIGIT )*
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:298:9: ( DIGIT )+
            int cnt6=0;
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( ((LA6_0>='0' && LA6_0<='9')) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:298:9: DIGIT
            	    {
            	    mDIGIT(); 

            	    }
            	    break;

            	default :
            	    if ( cnt6 >= 1 ) break loop6;
                        EarlyExitException eee =
                            new EarlyExitException(6, input);
                        throw eee;
                }
                cnt6++;
            } while (true);

            match('.'); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:298:20: ( DIGIT )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>='0' && LA7_0<='9')) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:298:20: DIGIT
            	    {
            	    mDIGIT(); 

            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end FLOAT

    // $ANTLR start ESC
    public final void mESC() throws RecognitionException {
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:302:2: ( '\\\\' ( 'n' | 'r' | 't' | 'b' | 'f' | '\"' | '\\'' | '\\\\' | ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:302:4: '\\\\' ( 'n' | 'r' | 't' | 'b' | 'f' | '\"' | '\\'' | '\\\\' | ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? ) )
            {
            match('\\'); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:303:3: ( 'n' | 'r' | 't' | 'b' | 'f' | '\"' | '\\'' | '\\\\' | ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? ) )
            int alt12=9;
            switch ( input.LA(1) ) {
            case 'n':
                {
                alt12=1;
                }
                break;
            case 'r':
                {
                alt12=2;
                }
                break;
            case 't':
                {
                alt12=3;
                }
                break;
            case 'b':
                {
                alt12=4;
                }
                break;
            case 'f':
                {
                alt12=5;
                }
                break;
            case '\"':
                {
                alt12=6;
                }
                break;
            case '\'':
                {
                alt12=7;
                }
                break;
            case '\\':
                {
                alt12=8;
                }
                break;
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
                {
                alt12=9;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("303:3: ( 'n' | 'r' | 't' | 'b' | 'f' | '\"' | '\\'' | '\\\\' | ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? ) )", 12, 0, input);

                throw nvae;
            }

            switch (alt12) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:303:5: 'n'
                    {
                    match('n'); 
                    setText("\n");

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:304:5: 'r'
                    {
                    match('r'); 
                    setText("\r");

                    }
                    break;
                case 3 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:305:5: 't'
                    {
                    match('t'); 
                    setText("\t");

                    }
                    break;
                case 4 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:306:5: 'b'
                    {
                    match('b'); 
                    setText("\b");

                    }
                    break;
                case 5 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:307:5: 'f'
                    {
                    match('f'); 
                    setText("\f");

                    }
                    break;
                case 6 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:308:5: '\"'
                    {
                    match('\"'); 
                    setText("\"");

                    }
                    break;
                case 7 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:309:5: '\\''
                    {
                    match('\''); 
                    setText("\'");

                    }
                    break;
                case 8 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:310:5: '\\\\'
                    {
                    match('\\'); 
                    setText("\\");

                    }
                    break;
                case 9 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:311:5: ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:311:5: ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? )
                    int alt11=2;
                    int LA11_0 = input.LA(1);

                    if ( ((LA11_0>='0' && LA11_0<='3')) ) {
                        alt11=1;
                    }
                    else if ( ((LA11_0>='4' && LA11_0<='7')) ) {
                        alt11=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("311:5: ( ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )? | ( '4' .. '7' ) ( ( '0' .. '7' ) )? )", 11, 0, input);

                        throw nvae;
                    }
                    switch (alt11) {
                        case 1 :
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:312:5: ( '0' .. '3' ) ( ( '0' .. '7' ) ( '0' .. '7' )? )?
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:312:5: ( '0' .. '3' )
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:312:6: '0' .. '3'
                            {
                            matchRange('0','3'); 

                            }

                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:313:5: ( ( '0' .. '7' ) ( '0' .. '7' )? )?
                            int alt9=2;
                            int LA9_0 = input.LA(1);

                            if ( ((LA9_0>='0' && LA9_0<='7')) ) {
                                alt9=1;
                            }
                            switch (alt9) {
                                case 1 :
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:317:7: ( '0' .. '7' ) ( '0' .. '7' )?
                                    {
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:317:7: ( '0' .. '7' )
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:317:8: '0' .. '7'
                                    {
                                    matchRange('0','7'); 

                                    }

                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:318:6: ( '0' .. '7' )?
                                    int alt8=2;
                                    int LA8_0 = input.LA(1);

                                    if ( ((LA8_0>='0' && LA8_0<='7')) ) {
                                        alt8=1;
                                    }
                                    switch (alt8) {
                                        case 1 :
                                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:322:8: '0' .. '7'
                                            {
                                            matchRange('0','7'); 

                                            }
                                            break;

                                    }


                                    }
                                    break;

                            }


                            }
                            break;
                        case 2 :
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:325:6: ( '4' .. '7' ) ( ( '0' .. '7' ) )?
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:325:6: ( '4' .. '7' )
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:325:7: '4' .. '7'
                            {
                            matchRange('4','7'); 

                            }

                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:326:5: ( ( '0' .. '7' ) )?
                            int alt10=2;
                            int LA10_0 = input.LA(1);

                            if ( ((LA10_0>='0' && LA10_0<='7')) ) {
                                alt10=1;
                            }
                            switch (alt10) {
                                case 1 :
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:330:7: ( '0' .. '7' )
                                    {
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:330:7: ( '0' .. '7' )
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:330:8: '0' .. '7'
                                    {
                                    matchRange('0','7'); 

                                    }


                                    }
                                    break;

                            }


                            }
                            break;

                    }

                    
                    					String s = getText();
                    					int i;
                    					int ret = 0;
                    					String ans;
                    					for (i=0; i<s.length(); ++i)
                    						ret = ret*8 + s.charAt(i) - '0';
                    					ans = String.valueOf((char) ret);
                    					setText(ans);
                    				

                    }
                    break;

            }


            }

        }
        finally {
        }
    }
    // $ANTLR end ESC

    // $ANTLR start STRING
    public final void mSTRING() throws RecognitionException {
        try {
            int _type = STRING;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:347:2: ( '\\'' ( ESC | '\\n' | ~ ( '\\\\' | '\\'' | '\\n' ) )* '\\'' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:347:4: '\\'' ( ESC | '\\n' | ~ ( '\\\\' | '\\'' | '\\n' ) )* '\\''
            {
            match('\''); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:348:3: ( ESC | '\\n' | ~ ( '\\\\' | '\\'' | '\\n' ) )*
            loop13:
            do {
                int alt13=4;
                int LA13_0 = input.LA(1);

                if ( (LA13_0=='\\') ) {
                    alt13=1;
                }
                else if ( (LA13_0=='\n') ) {
                    alt13=2;
                }
                else if ( ((LA13_0>='\u0000' && LA13_0<='\t')||(LA13_0>='\u000B' && LA13_0<='&')||(LA13_0>='(' && LA13_0<='[')||(LA13_0>=']' && LA13_0<='\uFFFE')) ) {
                    alt13=3;
                }


                switch (alt13) {
            	case 1 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:348:5: ESC
            	    {
            	    mESC(); 

            	    }
            	    break;
            	case 2 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:349:5: '\\n'
            	    {
            	    match('\n'); 
            	    newline();

            	    }
            	    break;
            	case 3 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:350:5: ~ ( '\\\\' | '\\'' | '\\n' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='&')||(input.LA(1)>='(' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFE') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

            match('\''); 
            setText(ei.unescapeString(getText(), 1));

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end STRING

    // $ANTLR start LSQUARE
    public final void mLSQUARE() throws RecognitionException {
        try {
            int _type = LSQUARE;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:359:2: ( '[' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:359:4: '['
            {
            match('['); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LSQUARE

    // $ANTLR start RSQUARE
    public final void mRSQUARE() throws RecognitionException {
        try {
            int _type = RSQUARE;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:367:2: ( ']' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:367:4: ']'
            {
            match(']'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RSQUARE

    // $ANTLR start EXCL
    public final void mEXCL() throws RecognitionException {
        try {
            int _type = EXCL;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:375:2: ( '!' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:375:4: '!'
            {
            match('!'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end EXCL

    // $ANTLR start COMA
    public final void mCOMA() throws RecognitionException {
        try {
            int _type = COMA;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:383:2: ( ',' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:383:4: ','
            {
            match(','); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COMA

    // $ANTLR start LPAREN
    public final void mLPAREN() throws RecognitionException {
        try {
            int _type = LPAREN;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:391:2: ( '(' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:391:4: '('
            {
            match('('); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LPAREN

    // $ANTLR start RPAREN
    public final void mRPAREN() throws RecognitionException {
        try {
            int _type = RPAREN;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:399:2: ( ')' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:399:4: ')'
            {
            match(')'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RPAREN

    // $ANTLR start LCURLY
    public final void mLCURLY() throws RecognitionException {
        try {
            int _type = LCURLY;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:407:2: ( '{' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:407:4: '{'
            {
            match('{'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LCURLY

    // $ANTLR start RCURLY
    public final void mRCURLY() throws RecognitionException {
        try {
            int _type = RCURLY;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:415:2: ( '}' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:415:4: '}'
            {
            match('}'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RCURLY

    // $ANTLR start SEMI
    public final void mSEMI() throws RecognitionException {
        try {
            int _type = SEMI;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:423:2: ( ';' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:423:4: ';'
            {
            match(';'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SEMI

    // $ANTLR start COLON
    public final void mCOLON() throws RecognitionException {
        try {
            int _type = COLON;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:431:2: ( ':' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:431:4: ':'
            {
            match(':'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COLON

    // $ANTLR start COLONS
    public final void mCOLONS() throws RecognitionException {
        try {
            int _type = COLONS;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:439:2: ( '::' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:439:4: '::'
            {
            match("::"); 


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COLONS

    // $ANTLR start PIPE
    public final void mPIPE() throws RecognitionException {
        try {
            int _type = PIPE;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:447:2: ( '|' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:447:4: '|'
            {
            match('|'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end PIPE

    // $ANTLR start SHARP
    public final void mSHARP() throws RecognitionException {
        try {
            int _type = SHARP;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:455:2: ( '#' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:455:4: '#'
            {
            match('#'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SHARP

    // $ANTLR start QMARK
    public final void mQMARK() throws RecognitionException {
        try {
            int _type = QMARK;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:463:2: ( '?' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:463:4: '?'
            {
            match('?'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end QMARK

    // $ANTLR start POINT
    public final void mPOINT() throws RecognitionException {
        try {
            int _type = POINT;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:471:2: ( '.' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:471:4: '.'
            {
            match('.'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end POINT

    // $ANTLR start RARROW
    public final void mRARROW() throws RecognitionException {
        try {
            int _type = RARROW;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:479:2: ( '->' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:479:4: '->'
            {
            match("->"); 


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RARROW

    // $ANTLR start MINUS
    public final void mMINUS() throws RecognitionException {
        try {
            int _type = MINUS;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:487:2: ( '-' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:487:4: '-'
            {
            match('-'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end MINUS

    // $ANTLR start STAR
    public final void mSTAR() throws RecognitionException {
        try {
            int _type = STAR;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:495:2: ( '*' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:495:4: '*'
            {
            match('*'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end STAR

    // $ANTLR start SLASH
    public final void mSLASH() throws RecognitionException {
        try {
            int _type = SLASH;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:503:2: ( '/' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:503:4: '/'
            {
            match('/'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SLASH

    // $ANTLR start PLUS
    public final void mPLUS() throws RecognitionException {
        try {
            int _type = PLUS;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:511:2: ( '+' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:511:4: '+'
            {
            match('+'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end PLUS

    // $ANTLR start EQ
    public final void mEQ() throws RecognitionException {
        try {
            int _type = EQ;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:519:2: ( '=' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:519:4: '='
            {
            match('='); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end EQ

    // $ANTLR start GT
    public final void mGT() throws RecognitionException {
        try {
            int _type = GT;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:527:2: ( '>' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:527:4: '>'
            {
            match('>'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end GT

    // $ANTLR start LT
    public final void mLT() throws RecognitionException {
        try {
            int _type = LT;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:535:2: ( '<' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:535:4: '<'
            {
            match('<'); 

                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LT

    // $ANTLR start GE
    public final void mGE() throws RecognitionException {
        try {
            int _type = GE;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:543:2: ( '>=' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:543:4: '>='
            {
            match(">="); 


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end GE

    // $ANTLR start LE
    public final void mLE() throws RecognitionException {
        try {
            int _type = LE;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:551:2: ( '<=' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:551:4: '<='
            {
            match("<="); 


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LE

    // $ANTLR start NE
    public final void mNE() throws RecognitionException {
        try {
            int _type = NE;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:559:2: ( '<>' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:559:4: '<>'
            {
            match("<>"); 


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end NE

    // $ANTLR start LARROW
    public final void mLARROW() throws RecognitionException {
        try {
            int _type = LARROW;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:567:2: ( '<-' )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:567:4: '<-'
            {
            match("<-"); 


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LARROW

    // $ANTLR start COMMENT
    public final void mCOMMENT() throws RecognitionException {
        try {
            int _type = COMMENT;
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:2: ( ( ( '--' (~ ( '\\r' | '\\n' ) )* ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:4: ( ( '--' (~ ( '\\r' | '\\n' ) )* ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:4: ( ( '--' (~ ( '\\r' | '\\n' ) )* ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:5: ( '--' (~ ( '\\r' | '\\n' ) )* )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:5: ( '--' (~ ( '\\r' | '\\n' ) )* )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:6: '--' (~ ( '\\r' | '\\n' ) )*
            {
            match("--"); 

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:11: (~ ( '\\r' | '\\n' ) )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( ((LA14_0>='\u0000' && LA14_0<='\t')||(LA14_0>='\u000B' && LA14_0<='\f')||(LA14_0>='\u000E' && LA14_0<='\uFFFE')) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:575:12: ~ ( '\\r' | '\\n' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFE') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);


            }


            }


                        
                    

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COMMENT

    public void mTokens() throws RecognitionException {
        // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:8: ( T42 | T43 | T44 | T45 | T46 | T47 | T48 | T49 | T50 | T51 | T52 | T53 | T54 | T55 | T56 | NL | WS | NAME | INT | FLOAT | STRING | LSQUARE | RSQUARE | EXCL | COMA | LPAREN | RPAREN | LCURLY | RCURLY | SEMI | COLON | COLONS | PIPE | SHARP | QMARK | POINT | RARROW | MINUS | STAR | SLASH | PLUS | EQ | GT | LT | GE | LE | NE | LARROW | COMMENT )
        int alt15=49;
        alt15 = dfa15.predict(input);
        switch (alt15) {
            case 1 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:10: T42
                {
                mT42(); 

                }
                break;
            case 2 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:14: T43
                {
                mT43(); 

                }
                break;
            case 3 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:18: T44
                {
                mT44(); 

                }
                break;
            case 4 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:22: T45
                {
                mT45(); 

                }
                break;
            case 5 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:26: T46
                {
                mT46(); 

                }
                break;
            case 6 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:30: T47
                {
                mT47(); 

                }
                break;
            case 7 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:34: T48
                {
                mT48(); 

                }
                break;
            case 8 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:38: T49
                {
                mT49(); 

                }
                break;
            case 9 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:42: T50
                {
                mT50(); 

                }
                break;
            case 10 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:46: T51
                {
                mT51(); 

                }
                break;
            case 11 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:50: T52
                {
                mT52(); 

                }
                break;
            case 12 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:54: T53
                {
                mT53(); 

                }
                break;
            case 13 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:58: T54
                {
                mT54(); 

                }
                break;
            case 14 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:62: T55
                {
                mT55(); 

                }
                break;
            case 15 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:66: T56
                {
                mT56(); 

                }
                break;
            case 16 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:70: NL
                {
                mNL(); 

                }
                break;
            case 17 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:73: WS
                {
                mWS(); 

                }
                break;
            case 18 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:76: NAME
                {
                mNAME(); 

                }
                break;
            case 19 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:81: INT
                {
                mINT(); 

                }
                break;
            case 20 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:85: FLOAT
                {
                mFLOAT(); 

                }
                break;
            case 21 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:91: STRING
                {
                mSTRING(); 

                }
                break;
            case 22 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:98: LSQUARE
                {
                mLSQUARE(); 

                }
                break;
            case 23 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:106: RSQUARE
                {
                mRSQUARE(); 

                }
                break;
            case 24 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:114: EXCL
                {
                mEXCL(); 

                }
                break;
            case 25 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:119: COMA
                {
                mCOMA(); 

                }
                break;
            case 26 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:124: LPAREN
                {
                mLPAREN(); 

                }
                break;
            case 27 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:131: RPAREN
                {
                mRPAREN(); 

                }
                break;
            case 28 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:138: LCURLY
                {
                mLCURLY(); 

                }
                break;
            case 29 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:145: RCURLY
                {
                mRCURLY(); 

                }
                break;
            case 30 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:152: SEMI
                {
                mSEMI(); 

                }
                break;
            case 31 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:157: COLON
                {
                mCOLON(); 

                }
                break;
            case 32 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:163: COLONS
                {
                mCOLONS(); 

                }
                break;
            case 33 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:170: PIPE
                {
                mPIPE(); 

                }
                break;
            case 34 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:175: SHARP
                {
                mSHARP(); 

                }
                break;
            case 35 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:181: QMARK
                {
                mQMARK(); 

                }
                break;
            case 36 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:187: POINT
                {
                mPOINT(); 

                }
                break;
            case 37 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:193: RARROW
                {
                mRARROW(); 

                }
                break;
            case 38 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:200: MINUS
                {
                mMINUS(); 

                }
                break;
            case 39 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:206: STAR
                {
                mSTAR(); 

                }
                break;
            case 40 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:211: SLASH
                {
                mSLASH(); 

                }
                break;
            case 41 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:217: PLUS
                {
                mPLUS(); 

                }
                break;
            case 42 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:222: EQ
                {
                mEQ(); 

                }
                break;
            case 43 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:225: GT
                {
                mGT(); 

                }
                break;
            case 44 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:228: LT
                {
                mLT(); 

                }
                break;
            case 45 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:231: GE
                {
                mGE(); 

                }
                break;
            case 46 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:234: LE
                {
                mLE(); 

                }
                break;
            case 47 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:237: NE
                {
                mNE(); 

                }
                break;
            case 48 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:240: LARROW
                {
                mLARROW(); 

                }
                break;
            case 49 :
                // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:1:247: COMMENT
                {
                mCOMMENT(); 

                }
                break;

        }

    }


    protected DFA15 dfa15 = new DFA15(this);
    static final String DFA15_eotS =
        "\1\uffff\12\15\3\uffff\1\63\12\uffff\1\66\4\uffff\1\71\4\uffff\1"+
        "\73\1\77\16\15\15\uffff\43\15\1\162\16\15\1\uffff\7\15\1\u0088\1"+
        "\15\1\u008a\4\15\1\u008f\2\15\1\u0092\2\15\1\u0095\1\uffff\1\u0096"+
        "\1\uffff\1\u0097\1\u0098\2\15\1\uffff\2\15\1\uffff\2\15\4\uffff"+
        "\1\u009f\1\u00a0\1\15\1\u00a2\1\u00a3\1\15\2\uffff\1\15\2\uffff"+
        "\1\u00a6\1\u00a7\2\uffff";
    static final String DFA15_eofS =
        "\u00a8\uffff";
    static final String DFA15_minS =
        "\1\11\2\141\1\142\1\154\1\156\1\145\1\165\1\160\1\156\1\151\3\uffff"+
        "\1\56\12\uffff\1\72\4\uffff\1\55\4\uffff\1\75\1\55\1\143\1\164\1"+
        "\163\1\164\1\156\1\141\1\164\1\165\1\146\1\142\1\145\1\144\1\151"+
        "\1\164\15\uffff\1\153\1\141\1\164\1\162\1\164\1\163\1\145\1\155"+
        "\1\145\1\163\1\162\1\157\1\145\1\161\1\145\1\141\1\164\1\162\1\151"+
        "\1\141\1\163\1\156\1\145\1\162\1\145\1\141\1\163\1\162\1\165\1\162"+
        "\1\147\1\171\1\141\1\142\1\151\1\60\1\144\1\162\1\145\2\164\1\151"+
        "\2\145\1\141\1\145\1\160\1\143\1\165\1\156\1\uffff\1\163\1\141\1"+
        "\156\1\163\1\151\1\164\1\144\1\60\1\154\1\60\1\145\2\164\1\145\1"+
        "\60\1\164\1\143\1\60\1\157\1\145\1\60\1\uffff\1\60\1\uffff\2\60"+
        "\1\145\1\162\1\uffff\1\151\1\145\1\uffff\1\156\1\117\4\uffff\2\60"+
        "\1\157\2\60\1\146\2\uffff\1\156\2\uffff\2\60\2\uffff";
    static final String DFA15_maxS =
        "\1\u00ff\2\141\1\164\1\157\1\170\1\145\1\165\1\162\1\156\1\151\3"+
        "\uffff\1\71\12\uffff\1\72\4\uffff\1\76\4\uffff\1\75\1\76\1\143\1"+
        "\164\1\163\1\164\1\156\1\141\1\164\1\165\1\146\1\142\1\160\1\144"+
        "\1\151\1\164\15\uffff\1\153\1\141\1\164\1\162\1\164\1\163\1\145"+
        "\1\155\1\145\1\163\1\162\1\157\1\145\1\161\1\145\1\141\1\164\1\162"+
        "\1\151\1\141\1\163\1\156\1\145\1\162\1\145\1\141\1\163\1\162\1\165"+
        "\1\162\1\147\1\171\1\141\1\142\1\151\1\u00ff\1\144\1\162\1\145\2"+
        "\164\1\151\2\145\1\141\1\145\1\160\1\143\1\165\1\156\1\uffff\1\163"+
        "\1\141\1\156\1\163\1\151\1\164\1\144\1\u00ff\1\154\1\u00ff\1\145"+
        "\2\164\1\145\1\u00ff\1\164\1\143\1\u00ff\1\157\1\145\1\u00ff\1\uffff"+
        "\1\u00ff\1\uffff\2\u00ff\1\145\1\162\1\uffff\1\151\1\145\1\uffff"+
        "\1\156\1\117\4\uffff\2\u00ff\1\157\2\u00ff\1\146\2\uffff\1\156\2"+
        "\uffff\2\u00ff\2\uffff";
    static final String DFA15_acceptS =
        "\13\uffff\1\20\1\21\1\22\1\uffff\1\25\1\26\1\27\1\30\1\31\1\32\1"+
        "\33\1\34\1\35\1\36\1\uffff\1\41\1\42\1\43\1\44\1\uffff\1\47\1\50"+
        "\1\51\1\52\20\uffff\1\23\1\24\1\40\1\37\1\45\1\61\1\46\1\55\1\53"+
        "\1\57\1\56\1\60\1\54\62\uffff\1\4\25\uffff\1\13\1\uffff\1\1\4\uffff"+
        "\1\5\2\uffff\1\10\2\uffff\1\17\1\16\1\2\1\3\6\uffff\1\12\1\7\1\uffff"+
        "\1\6\1\14\2\uffff\1\11\1\15";
    static final String DFA15_specialS =
        "\u00a8\uffff}>";
    static final String[] DFA15_transitionS = {
            "\1\14\1\13\2\uffff\1\13\22\uffff\1\14\1\22\1\15\1\33\3\uffff"+
            "\1\17\1\24\1\25\1\37\1\41\1\23\1\36\1\35\1\40\12\16\1\31\1\30"+
            "\1\44\1\42\1\43\1\34\1\uffff\32\15\1\20\1\uffff\1\21\1\uffff"+
            "\1\15\1\uffff\1\3\1\15\1\4\1\2\1\5\6\15\1\12\2\15\1\10\1\1\1"+
            "\15\1\6\1\7\1\15\1\11\5\15\1\26\1\32\1\27\102\uffff\27\15\1"+
            "\uffff\37\15\1\uffff\10\15",
            "\1\45",
            "\1\46",
            "\1\47\21\uffff\1\50",
            "\1\52\2\uffff\1\51",
            "\1\54\11\uffff\1\53",
            "\1\55",
            "\1\56",
            "\1\57\1\uffff\1\60",
            "\1\61",
            "\1\62",
            "",
            "",
            "",
            "\1\64\1\uffff\12\16",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\65",
            "",
            "",
            "",
            "",
            "\1\70\20\uffff\1\67",
            "",
            "",
            "",
            "",
            "\1\72",
            "\1\76\17\uffff\1\75\1\74",
            "\1\100",
            "\1\101",
            "\1\102",
            "\1\103",
            "\1\104",
            "\1\105",
            "\1\106",
            "\1\107",
            "\1\110",
            "\1\111",
            "\1\112\12\uffff\1\113",
            "\1\114",
            "\1\115",
            "\1\116",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\117",
            "\1\120",
            "\1\121",
            "\1\122",
            "\1\123",
            "\1\124",
            "\1\125",
            "\1\126",
            "\1\127",
            "\1\130",
            "\1\131",
            "\1\132",
            "\1\133",
            "\1\134",
            "\1\135",
            "\1\136",
            "\1\137",
            "\1\140",
            "\1\141",
            "\1\142",
            "\1\143",
            "\1\144",
            "\1\145",
            "\1\146",
            "\1\147",
            "\1\150",
            "\1\151",
            "\1\152",
            "\1\153",
            "\1\154",
            "\1\155",
            "\1\156",
            "\1\157",
            "\1\160",
            "\1\161",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\163",
            "\1\164",
            "\1\165",
            "\1\166",
            "\1\167",
            "\1\170",
            "\1\171",
            "\1\172",
            "\1\173",
            "\1\174",
            "\1\175",
            "\1\176",
            "\1\177",
            "\1\u0080",
            "",
            "\1\u0081",
            "\1\u0082",
            "\1\u0083",
            "\1\u0084",
            "\1\u0085",
            "\1\u0086",
            "\1\u0087",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u0089",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u008b",
            "\1\u008c",
            "\1\u008d",
            "\1\u008e",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u0090",
            "\1\u0091",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u0093",
            "\1\u0094",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u0099",
            "\1\u009a",
            "",
            "\1\u009b",
            "\1\u009c",
            "",
            "\1\u009d",
            "\1\u009e",
            "",
            "",
            "",
            "",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u00a1",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\1\u00a4",
            "",
            "",
            "\1\u00a5",
            "",
            "",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15\105\uffff\27"+
            "\15\1\uffff\37\15\1\uffff\10\15",
            "",
            ""
    };

    static final short[] DFA15_eot = DFA.unpackEncodedString(DFA15_eotS);
    static final short[] DFA15_eof = DFA.unpackEncodedString(DFA15_eofS);
    static final char[] DFA15_min = DFA.unpackEncodedStringToUnsignedChars(DFA15_minS);
    static final char[] DFA15_max = DFA.unpackEncodedStringToUnsignedChars(DFA15_maxS);
    static final short[] DFA15_accept = DFA.unpackEncodedString(DFA15_acceptS);
    static final short[] DFA15_special = DFA.unpackEncodedString(DFA15_specialS);
    static final short[][] DFA15_transition;

    static {
        int numStates = DFA15_transitionS.length;
        DFA15_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA15_transition[i] = DFA.unpackEncodedString(DFA15_transitionS[i]);
        }
    }

    class DFA15 extends DFA {

        public DFA15(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 15;
            this.eot = DFA15_eot;
            this.eof = DFA15_eof;
            this.min = DFA15_min;
            this.max = DFA15_max;
            this.accept = DFA15_accept;
            this.special = DFA15_special;
            this.transition = DFA15_transition;
        }
        public String getDescription() {
            return "1:1: Tokens : ( T42 | T43 | T44 | T45 | T46 | T47 | T48 | T49 | T50 | T51 | T52 | T53 | T54 | T55 | T56 | NL | WS | NAME | INT | FLOAT | STRING | LSQUARE | RSQUARE | EXCL | COMA | LPAREN | RPAREN | LCURLY | RCURLY | SEMI | COLON | COLONS | PIPE | SHARP | QMARK | POINT | RARROW | MINUS | STAR | SLASH | PLUS | EQ | GT | LT | GE | LE | NE | LARROW | COMMENT );";
        }
    }
 

}