/*******************************************************************************
 * Copyright (c) 2005-2008 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Frderic Jouault
 *******************************************************************************/

//  This file has been generated using ANTLR 3.0.1

// $ANTLR 3.0.1 C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g 2008-07-01 14:11:58
package org.eclipse.gmt.tcs.injector;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class KM3_ANTLR3Parser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NAME", "STRING", "INT", "LCURLY", "RCURLY", "SEMI", "COMA", "COLON", "LPAREN", "RPAREN", "LSQUARE", "STAR", "RSQUARE", "MINUS", "NL", "WS", "DIGIT", "ALPHA", "SNAME", "ESC", "FLOAT", "EXCL", "COLONS", "PIPE", "SHARP", "QMARK", "POINT", "RARROW", "SLASH", "PLUS", "EQ", "GT", "LT", "GE", "LE", "NE", "LARROW", "COMMENT", "'package'", "'datatype'", "'abstract'", "'class'", "'extends'", "'reference'", "'container'", "'subsets'", "'oppositeOf'", "'attribute'", "'unique'", "'operation'", "'enumeration'", "'literal'", "'ordered'"
    };
    public static final int GE=37;
    public static final int LT=36;
    public static final int STAR=15;
    public static final int LSQUARE=14;
    public static final int SHARP=28;
    public static final int POINT=30;
    public static final int ESC=23;
    public static final int RARROW=31;
    public static final int LARROW=40;
    public static final int LCURLY=7;
    public static final int EXCL=25;
    public static final int FLOAT=24;
    public static final int INT=6;
    public static final int RSQUARE=16;
    public static final int MINUS=17;
    public static final int EOF=-1;
    public static final int COMA=10;
    public static final int SEMI=9;
    public static final int ALPHA=21;
    public static final int LPAREN=12;
    public static final int COLONS=26;
    public static final int COLON=11;
    public static final int RPAREN=13;
    public static final int NAME=4;
    public static final int SLASH=32;
    public static final int WS=19;
    public static final int SNAME=22;
    public static final int RCURLY=8;
    public static final int GT=35;
    public static final int PLUS=33;
    public static final int PIPE=27;
    public static final int DIGIT=20;
    public static final int NL=18;
    public static final int EQ=34;
    public static final int COMMENT=41;
    public static final int QMARK=29;
    public static final int LE=38;
    public static final int STRING=5;
    public static final int NE=39;

        public KM3_ANTLR3Parser(TokenStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g"; }


        public org.eclipse.gmt.tcs.injector.TCSRuntime ei = null;
        
    //	public void reportError(RecognitionException ex) {
    //		ei.reportError((Exception)ex);
    //	}
    	
    //	public void emitErrorMessage(String s) {
    //		ei.reportError(s);
    //	}

    	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
    		ei.reportError((Exception)e);
    	}

    	//TODO: what about warnings?
    //	public void reportWarning(String s) {
    //		ei.reportWarning(s);
    //	}
    	
        public static void main(String[] args) throws Exception {
    						CharStream input = new ANTLRFileStream(args[0]);
        KM3_ANTLR3Lexer lex = new 
        KM3_ANTLR3Lexer(input);
    						CommonTokenStream tokens = new CommonTokenStream(lex);
    						tokens.discardTokenType(WS);
    						tokens.discardTokenType(COMMENT);
    						tokens.discardTokenType(NL);
    						
        KM3_ANTLR3Parser parser = new 
        KM3_ANTLR3Parser(tokens);
    						parser.main();
    					}



    // $ANTLR start main
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:60:1: main returns [Object ret2] : ( (ret= metamodel ) EOF ) ;
    public final Object main() throws RecognitionException {
        Object ret2 = null;

        Object ret = null;


        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:61:2: ( ( (ret= metamodel ) EOF ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:61:4: ( (ret= metamodel ) EOF )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:61:4: ( (ret= metamodel ) EOF )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:61:5: (ret= metamodel ) EOF
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:61:5: (ret= metamodel )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:61:6: ret= metamodel
            {
            pushFollow(FOLLOW_metamodel_in_main46);
            ret=metamodel();
            _fsp--;


            }

            match(input,EOF,FOLLOW_EOF_in_main49); 

            }


                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end main


    // $ANTLR start identifier
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:68:1: identifier returns [Object ret2] : ast= NAME ;
    public final Object identifier() throws RecognitionException {
        Object ret2 = null;

        Token ast=null;

        java.lang.Object ret=null;
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:69:2: (ast= NAME )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:69:4: ast= NAME
            {
            ast=(Token)input.LT(1);
            match(input,NAME,FOLLOW_NAME_in_identifier82); 
            ret = ast.getText(); ei.setToken((Object)ast);

                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end identifier


    // $ANTLR start stringSymbol
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:76:1: stringSymbol returns [Object ret2] : ast= STRING ;
    public final Object stringSymbol() throws RecognitionException {
        Object ret2 = null;

        Token ast=null;

        java.lang.Object ret=null;
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:77:2: (ast= STRING )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:77:4: ast= STRING
            {
            ast=(Token)input.LT(1);
            match(input,STRING,FOLLOW_STRING_in_stringSymbol116); 
            ret = ast.getText(); ei.setToken((Object)ast);

                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end stringSymbol


    // $ANTLR start integerSymbol
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:84:1: integerSymbol returns [Object ret2] : ast= INT ;
    public final Object integerSymbol() throws RecognitionException {
        Object ret2 = null;

        Token ast=null;

        java.lang.Object ret=null;
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:85:2: (ast= INT )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:85:4: ast= INT
            {
            ast=(Token)input.LT(1);
            match(input,INT,FOLLOW_INT_in_integerSymbol150); 
            ret = Integer.valueOf(ast.getText()); ei.setToken((Object)ast);

                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end integerSymbol


    // $ANTLR start metamodel
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:92:1: metamodel returns [Object ret2] : ( ( ( ( (temp= package_ ( (temp= package_ ) )* ) )? ) ) ) ;
    public final Object metamodel() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Metamodel", true, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:2: ( ( ( ( ( (temp= package_ ( (temp= package_ ) )* ) )? ) ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:4: ( ( ( ( (temp= package_ ( (temp= package_ ) )* ) )? ) ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:4: ( ( ( ( (temp= package_ ( (temp= package_ ) )* ) )? ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:5: ( ( ( (temp= package_ ( (temp= package_ ) )* ) )? ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:5: ( ( ( (temp= package_ ( (temp= package_ ) )* ) )? ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:6: ( ( (temp= package_ ( (temp= package_ ) )* ) )? )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:6: ( ( (temp= package_ ( (temp= package_ ) )* ) )? )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:7: ( (temp= package_ ( (temp= package_ ) )* ) )?
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:7: ( (temp= package_ ( (temp= package_ ) )* ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==42) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:8: (temp= package_ ( (temp= package_ ) )* )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:8: (temp= package_ ( (temp= package_ ) )* )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:9: temp= package_ ( (temp= package_ ) )*
                    {
                    pushFollow(FOLLOW_package__in_metamodel189);
                    temp=package_();
                    _fsp--;

                    ei.set(ret, "contents", temp);
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:56: ( (temp= package_ ) )*
                    loop1:
                    do {
                        int alt1=2;
                        int LA1_0 = input.LA(1);

                        if ( (LA1_0==42) ) {
                            alt1=1;
                        }


                        switch (alt1) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:57: (temp= package_ )
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:57: (temp= package_ )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:93:58: temp= package_
                    	    {
                    	    pushFollow(FOLLOW_package__in_metamodel197);
                    	    temp=package_();
                    	    _fsp--;

                    	    ei.set(ret, "contents", temp);

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop1;
                        }
                    } while (true);


                    }


                    }
                    break;

            }


            }


            }


            }


                        ei.leaveContext(true);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end metamodel


    // $ANTLR start modelElement
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:103:1: modelElement returns [Object ret2] : ( (ret= classifier | ret= package_ | ret= enumLiteral ) ) ;
    public final Object modelElement() throws RecognitionException {
        Object ret2 = null;

        Object ret = null;


        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:2: ( ( (ret= classifier | ret= package_ | ret= enumLiteral ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:4: ( (ret= classifier | ret= package_ | ret= enumLiteral ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:4: ( (ret= classifier | ret= package_ | ret= enumLiteral ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:5: (ret= classifier | ret= package_ | ret= enumLiteral )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:5: (ret= classifier | ret= package_ | ret= enumLiteral )
            int alt3=3;
            switch ( input.LA(1) ) {
            case 43:
            case 44:
            case 45:
            case 54:
                {
                alt3=1;
                }
                break;
            case 42:
                {
                alt3=2;
                }
                break;
            case 55:
                {
                alt3=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("104:5: (ret= classifier | ret= package_ | ret= enumLiteral )", 3, 0, input);

                throw nvae;
            }

            switch (alt3) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:6: ret= classifier
                    {
                    pushFollow(FOLLOW_classifier_in_modelElement242);
                    ret=classifier();
                    _fsp--;


                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:22: ret= package_
                    {
                    pushFollow(FOLLOW_package__in_modelElement247);
                    ret=package_();
                    _fsp--;


                    }
                    break;
                case 3 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:104:36: ret= enumLiteral
                    {
                    pushFollow(FOLLOW_enumLiteral_in_modelElement252);
                    ret=enumLiteral();
                    _fsp--;


                    }
                    break;

            }


            }


                        ei.addToContext(ret, false);
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end modelElement


    // $ANTLR start classifier
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:112:1: classifier returns [Object ret2] : ( (ret= dataType | ret= class_ | ret= enumeration ) ) ;
    public final Object classifier() throws RecognitionException {
        Object ret2 = null;

        Object ret = null;


        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:2: ( ( (ret= dataType | ret= class_ | ret= enumeration ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:4: ( (ret= dataType | ret= class_ | ret= enumeration ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:4: ( (ret= dataType | ret= class_ | ret= enumeration ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:5: (ret= dataType | ret= class_ | ret= enumeration )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:5: (ret= dataType | ret= class_ | ret= enumeration )
            int alt4=3;
            switch ( input.LA(1) ) {
            case 43:
                {
                alt4=1;
                }
                break;
            case 44:
            case 45:
                {
                alt4=2;
                }
                break;
            case 54:
                {
                alt4=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("113:5: (ret= dataType | ret= class_ | ret= enumeration )", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:6: ret= dataType
                    {
                    pushFollow(FOLLOW_dataType_in_classifier288);
                    ret=dataType();
                    _fsp--;


                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:20: ret= class_
                    {
                    pushFollow(FOLLOW_class__in_classifier293);
                    ret=class_();
                    _fsp--;


                    }
                    break;
                case 3 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:113:32: ret= enumeration
                    {
                    pushFollow(FOLLOW_enumeration_in_classifier298);
                    ret=enumeration();
                    _fsp--;


                    }
                    break;

            }


            }


                        ei.addToContext(ret, true);
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end classifier


    // $ANTLR start package_
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:121:1: package_ returns [Object ret2] : ( 'package' temp= identifier LCURLY ( ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? ) ) RCURLY ) ;
    public final Object package_() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Package", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:2: ( ( 'package' temp= identifier LCURLY ( ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? ) ) RCURLY ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:4: ( 'package' temp= identifier LCURLY ( ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? ) ) RCURLY )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:4: ( 'package' temp= identifier LCURLY ( ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? ) ) RCURLY )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:5: 'package' temp= identifier LCURLY ( ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? ) ) RCURLY
            {
            match(input,42,FOLLOW_42_in_package_331); 
            pushFollow(FOLLOW_identifier_in_package_335);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            match(input,LCURLY,FOLLOW_LCURLY_in_package_339); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:67: ( ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:68: ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:68: ( ( (temp= modelElement ( (temp= modelElement ) )* ) )? )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:69: ( (temp= modelElement ( (temp= modelElement ) )* ) )?
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:69: ( (temp= modelElement ( (temp= modelElement ) )* ) )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( ((LA6_0>=42 && LA6_0<=45)||(LA6_0>=54 && LA6_0<=55)) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:70: (temp= modelElement ( (temp= modelElement ) )* )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:70: (temp= modelElement ( (temp= modelElement ) )* )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:71: temp= modelElement ( (temp= modelElement ) )*
                    {
                    pushFollow(FOLLOW_modelElement_in_package_347);
                    temp=modelElement();
                    _fsp--;

                    ei.set(ret, "contents", temp);
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:122: ( (temp= modelElement ) )*
                    loop5:
                    do {
                        int alt5=2;
                        int LA5_0 = input.LA(1);

                        if ( ((LA5_0>=42 && LA5_0<=45)||(LA5_0>=54 && LA5_0<=55)) ) {
                            alt5=1;
                        }


                        switch (alt5) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:123: (temp= modelElement )
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:123: (temp= modelElement )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:122:124: temp= modelElement
                    	    {
                    	    pushFollow(FOLLOW_modelElement_in_package_355);
                    	    temp=modelElement();
                    	    _fsp--;

                    	    ei.set(ret, "contents", temp);

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);


                    }


                    }
                    break;

            }


            }


            }

            match(input,RCURLY,FOLLOW_RCURLY_in_package_367); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end package_


    // $ANTLR start dataType
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:132:1: dataType returns [Object ret2] : ( 'datatype' temp= identifier SEMI ) ;
    public final Object dataType() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("DataType", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:133:2: ( ( 'datatype' temp= identifier SEMI ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:133:4: ( 'datatype' temp= identifier SEMI )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:133:4: ( 'datatype' temp= identifier SEMI )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:133:5: 'datatype' temp= identifier SEMI
            {
            match(input,43,FOLLOW_43_in_dataType399); 
            pushFollow(FOLLOW_identifier_in_dataType403);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            match(input,SEMI,FOLLOW_SEMI_in_dataType407); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end dataType


    // $ANTLR start class_
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:143:1: class_ returns [Object ret2] : ( ( ( 'abstract' ) | () ) 'class' temp= identifier ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) LCURLY ( ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? ) ) RCURLY ) ;
    public final Object class_() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Class", true, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:2: ( ( ( ( 'abstract' ) | () ) 'class' temp= identifier ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) LCURLY ( ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? ) ) RCURLY ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:4: ( ( ( 'abstract' ) | () ) 'class' temp= identifier ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) LCURLY ( ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? ) ) RCURLY )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:4: ( ( ( 'abstract' ) | () ) 'class' temp= identifier ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) LCURLY ( ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? ) ) RCURLY )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:5: ( ( 'abstract' ) | () ) 'class' temp= identifier ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) LCURLY ( ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? ) ) RCURLY
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:5: ( ( 'abstract' ) | () )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==44) ) {
                alt7=1;
            }
            else if ( (LA7_0==45) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("144:5: ( ( 'abstract' ) | () )", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:6: ( 'abstract' )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:6: ( 'abstract' )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:7: 'abstract'
                    {
                    match(input,44,FOLLOW_44_in_class_441); 

                    }

                    ei.set(ret, "isAbstract", java.lang.Boolean.TRUE);

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:73: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:73: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:74: 
                    {
                    }

                    ei.set(ret, "isAbstract", java.lang.Boolean.FALSE);

                    }
                    break;

            }

            match(input,45,FOLLOW_45_in_class_453); 
            pushFollow(FOLLOW_identifier_in_class_457);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:184: ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==46) ) {
                alt10=1;
            }
            else if ( (LA10_0==LCURLY) ) {
                alt10=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("144:184: ( ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () )", 10, 0, input);

                throw nvae;
            }
            switch (alt10) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:185: ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:185: ( 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:186: 'extends' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )?
                    {
                    match(input,46,FOLLOW_46_in_class_463); 
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:196: ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )?
                    int alt9=2;
                    int LA9_0 = input.LA(1);

                    if ( (LA9_0==NAME) ) {
                        alt9=1;
                    }
                    switch (alt9) {
                        case 1 :
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:197: (temp= identifier ( ( ( COMA ) temp= identifier ) )* )
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:197: (temp= identifier ( ( ( COMA ) temp= identifier ) )* )
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:198: temp= identifier ( ( ( COMA ) temp= identifier ) )*
                            {
                            pushFollow(FOLLOW_identifier_in_class_469);
                            temp=identifier();
                            _fsp--;

                            ei.setRef(ret, "supertypes", "Class", "name", temp, null, "never", null, true, null);
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:302: ( ( ( COMA ) temp= identifier ) )*
                            loop8:
                            do {
                                int alt8=2;
                                int LA8_0 = input.LA(1);

                                if ( (LA8_0==COMA) ) {
                                    alt8=1;
                                }


                                switch (alt8) {
                            	case 1 :
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:303: ( ( COMA ) temp= identifier )
                            	    {
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:303: ( ( COMA ) temp= identifier )
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:304: ( COMA ) temp= identifier
                            	    {
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:304: ( COMA )
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:305: COMA
                            	    {
                            	    match(input,COMA,FOLLOW_COMA_in_class_476); 

                            	    }

                            	    pushFollow(FOLLOW_identifier_in_class_481);
                            	    temp=identifier();
                            	    _fsp--;

                            	    ei.setRef(ret, "supertypes", "Class", "name", temp, null, "never", null, true, null);

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop8;
                                }
                            } while (true);


                            }


                            }
                            break;

                    }


                    }



                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:426: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:426: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:427: 
                    {
                    }



                    }
                    break;

            }

            match(input,LCURLY,FOLLOW_LCURLY_in_class_501); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:440: ( ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:441: ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:441: ( ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )? )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:442: ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )? ( (temp= operation ( (temp= operation ) )* ) )?
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:442: ( (temp= structuralFeature ( (temp= structuralFeature ) )* ) )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==47||LA12_0==51) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:443: (temp= structuralFeature ( (temp= structuralFeature ) )* )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:443: (temp= structuralFeature ( (temp= structuralFeature ) )* )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:444: temp= structuralFeature ( (temp= structuralFeature ) )*
                    {
                    pushFollow(FOLLOW_structuralFeature_in_class_509);
                    temp=structuralFeature();
                    _fsp--;

                    ei.set(ret, "structuralFeatures", temp);
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:510: ( (temp= structuralFeature ) )*
                    loop11:
                    do {
                        int alt11=2;
                        int LA11_0 = input.LA(1);

                        if ( (LA11_0==47||LA11_0==51) ) {
                            alt11=1;
                        }


                        switch (alt11) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:511: (temp= structuralFeature )
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:511: (temp= structuralFeature )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:512: temp= structuralFeature
                    	    {
                    	    pushFollow(FOLLOW_structuralFeature_in_class_517);
                    	    temp=structuralFeature();
                    	    _fsp--;

                    	    ei.set(ret, "structuralFeatures", temp);

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop11;
                        }
                    } while (true);


                    }


                    }
                    break;

            }

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:584: ( (temp= operation ( (temp= operation ) )* ) )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==53) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:585: (temp= operation ( (temp= operation ) )* )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:585: (temp= operation ( (temp= operation ) )* )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:586: temp= operation ( (temp= operation ) )*
                    {
                    pushFollow(FOLLOW_operation_in_class_531);
                    temp=operation();
                    _fsp--;

                    ei.set(ret, "operations", temp);
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:636: ( (temp= operation ) )*
                    loop13:
                    do {
                        int alt13=2;
                        int LA13_0 = input.LA(1);

                        if ( (LA13_0==53) ) {
                            alt13=1;
                        }


                        switch (alt13) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:637: (temp= operation )
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:637: (temp= operation )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:144:638: temp= operation
                    	    {
                    	    pushFollow(FOLLOW_operation_in_class_539);
                    	    temp=operation();
                    	    _fsp--;

                    	    ei.set(ret, "operations", temp);

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop13;
                        }
                    } while (true);


                    }


                    }
                    break;

            }


            }


            }

            match(input,RCURLY,FOLLOW_RCURLY_in_class_551); 

            }


                        ei.leaveContext(true);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end class_


    // $ANTLR start structuralFeature
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:154:1: structuralFeature returns [Object ret2] : ( (ret= reference | ret= attribute ) ) ;
    public final Object structuralFeature() throws RecognitionException {
        Object ret2 = null;

        Object ret = null;


        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:2: ( ( (ret= reference | ret= attribute ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:4: ( (ret= reference | ret= attribute ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:4: ( (ret= reference | ret= attribute ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:5: (ret= reference | ret= attribute )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:5: (ret= reference | ret= attribute )
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==47) ) {
                alt15=1;
            }
            else if ( (LA15_0==51) ) {
                alt15=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("155:5: (ret= reference | ret= attribute )", 15, 0, input);

                throw nvae;
            }
            switch (alt15) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:6: ret= reference
                    {
                    pushFollow(FOLLOW_reference_in_structuralFeature586);
                    ret=reference();
                    _fsp--;


                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:155:21: ret= attribute
                    {
                    pushFollow(FOLLOW_attribute_in_structuralFeature591);
                    ret=attribute();
                    _fsp--;


                    }
                    break;

            }


            }


                        ei.addToContext(ret, false);
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end structuralFeature


    // $ANTLR start reference
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:163:1: reference returns [Object ret2] : ( 'reference' temp= identifier multiplicity[ret] ( ( 'container' ) | () ) ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) COLON temp= identifier ( ( 'oppositeOf' temp= identifier ) | () ) SEMI ) ;
    public final Object reference() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Reference", false, true) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:2: ( ( 'reference' temp= identifier multiplicity[ret] ( ( 'container' ) | () ) ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) COLON temp= identifier ( ( 'oppositeOf' temp= identifier ) | () ) SEMI ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:4: ( 'reference' temp= identifier multiplicity[ret] ( ( 'container' ) | () ) ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) COLON temp= identifier ( ( 'oppositeOf' temp= identifier ) | () ) SEMI )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:4: ( 'reference' temp= identifier multiplicity[ret] ( ( 'container' ) | () ) ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) COLON temp= identifier ( ( 'oppositeOf' temp= identifier ) | () ) SEMI )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:5: 'reference' temp= identifier multiplicity[ret] ( ( 'container' ) | () ) ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () ) COLON temp= identifier ( ( 'oppositeOf' temp= identifier ) | () ) SEMI
            {
            match(input,47,FOLLOW_47_in_reference624); 
            pushFollow(FOLLOW_identifier_in_reference628);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            pushFollow(FOLLOW_multiplicity_in_reference632);
            multiplicity(ret);
            _fsp--;

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:80: ( ( 'container' ) | () )
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==48) ) {
                alt16=1;
            }
            else if ( (LA16_0==COLON||LA16_0==49) ) {
                alt16=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("164:80: ( ( 'container' ) | () )", 16, 0, input);

                throw nvae;
            }
            switch (alt16) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:81: ( 'container' )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:81: ( 'container' )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:82: 'container'
                    {
                    match(input,48,FOLLOW_48_in_reference637); 

                    }

                    ei.set(ret, "isContainer", java.lang.Boolean.TRUE);

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:150: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:150: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:151: 
                    {
                    }

                    ei.set(ret, "isContainer", java.lang.Boolean.FALSE);

                    }
                    break;

            }

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:209: ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () )
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==49) ) {
                alt19=1;
            }
            else if ( (LA19_0==COLON) ) {
                alt19=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("164:209: ( ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? ) | () )", 19, 0, input);

                throw nvae;
            }
            switch (alt19) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:210: ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:210: ( 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )? )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:211: 'subsets' ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )?
                    {
                    match(input,49,FOLLOW_49_in_reference651); 
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:221: ( (temp= identifier ( ( ( COMA ) temp= identifier ) )* ) )?
                    int alt18=2;
                    int LA18_0 = input.LA(1);

                    if ( (LA18_0==NAME) ) {
                        alt18=1;
                    }
                    switch (alt18) {
                        case 1 :
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:222: (temp= identifier ( ( ( COMA ) temp= identifier ) )* )
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:222: (temp= identifier ( ( ( COMA ) temp= identifier ) )* )
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:223: temp= identifier ( ( ( COMA ) temp= identifier ) )*
                            {
                            pushFollow(FOLLOW_identifier_in_reference657);
                            temp=identifier();
                            _fsp--;

                            ei.setRef(ret, "subsetOf", "StructuralFeature", "name", temp, null, "never", null, false, null);
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:338: ( ( ( COMA ) temp= identifier ) )*
                            loop17:
                            do {
                                int alt17=2;
                                int LA17_0 = input.LA(1);

                                if ( (LA17_0==COMA) ) {
                                    alt17=1;
                                }


                                switch (alt17) {
                            	case 1 :
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:339: ( ( COMA ) temp= identifier )
                            	    {
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:339: ( ( COMA ) temp= identifier )
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:340: ( COMA ) temp= identifier
                            	    {
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:340: ( COMA )
                            	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:341: COMA
                            	    {
                            	    match(input,COMA,FOLLOW_COMA_in_reference664); 

                            	    }

                            	    pushFollow(FOLLOW_identifier_in_reference669);
                            	    temp=identifier();
                            	    _fsp--;

                            	    ei.setRef(ret, "subsetOf", "StructuralFeature", "name", temp, null, "never", null, false, null);

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop17;
                                }
                            } while (true);


                            }


                            }
                            break;

                    }


                    }



                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:473: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:473: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:474: 
                    {
                    }



                    }
                    break;

            }

            match(input,COLON,FOLLOW_COLON_in_reference689); 
            pushFollow(FOLLOW_identifier_in_reference693);
            temp=identifier();
            _fsp--;

            ei.setRef(ret, "type", "Classifier", "name", temp, null, "never", null, false, null);
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:590: ( ( 'oppositeOf' temp= identifier ) | () )
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==50) ) {
                alt20=1;
            }
            else if ( (LA20_0==SEMI) ) {
                alt20=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("164:590: ( ( 'oppositeOf' temp= identifier ) | () )", 20, 0, input);

                throw nvae;
            }
            switch (alt20) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:591: ( 'oppositeOf' temp= identifier )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:591: ( 'oppositeOf' temp= identifier )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:592: 'oppositeOf' temp= identifier
                    {
                    match(input,50,FOLLOW_50_in_reference699); 
                    pushFollow(FOLLOW_identifier_in_reference703);
                    temp=identifier();
                    _fsp--;

                    ei.setRef(ret, "opposite", "Reference", "name", temp, "type", "never", null, false, null);

                    }



                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:719: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:719: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:164:720: 
                    {
                    }



                    }
                    break;

            }

            match(input,SEMI,FOLLOW_SEMI_in_reference717); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end reference


    // $ANTLR start attribute
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:174:1: attribute returns [Object ret2] : ( 'attribute' temp= identifier multiplicity[ret] ( ( 'unique' ) | () ) COLON temp= identifier SEMI ) ;
    public final Object attribute() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Attribute", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:2: ( ( 'attribute' temp= identifier multiplicity[ret] ( ( 'unique' ) | () ) COLON temp= identifier SEMI ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:4: ( 'attribute' temp= identifier multiplicity[ret] ( ( 'unique' ) | () ) COLON temp= identifier SEMI )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:4: ( 'attribute' temp= identifier multiplicity[ret] ( ( 'unique' ) | () ) COLON temp= identifier SEMI )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:5: 'attribute' temp= identifier multiplicity[ret] ( ( 'unique' ) | () ) COLON temp= identifier SEMI
            {
            match(input,51,FOLLOW_51_in_attribute749); 
            pushFollow(FOLLOW_identifier_in_attribute753);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            pushFollow(FOLLOW_multiplicity_in_attribute757);
            multiplicity(ret);
            _fsp--;

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:80: ( ( 'unique' ) | () )
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==52) ) {
                alt21=1;
            }
            else if ( (LA21_0==COLON) ) {
                alt21=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("175:80: ( ( 'unique' ) | () )", 21, 0, input);

                throw nvae;
            }
            switch (alt21) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:81: ( 'unique' )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:81: ( 'unique' )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:82: 'unique'
                    {
                    match(input,52,FOLLOW_52_in_attribute762); 

                    }

                    ei.set(ret, "isUnique", java.lang.Boolean.TRUE);

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:144: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:144: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:175:145: 
                    {
                    }

                    ei.set(ret, "isUnique", java.lang.Boolean.FALSE);

                    }
                    break;

            }

            match(input,COLON,FOLLOW_COLON_in_attribute774); 
            pushFollow(FOLLOW_identifier_in_attribute778);
            temp=identifier();
            _fsp--;

            ei.setRef(ret, "type", "Classifier", "name", temp, null, "never", null, false, null);
            match(input,SEMI,FOLLOW_SEMI_in_attribute782); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end attribute


    // $ANTLR start operation
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:185:1: operation returns [Object ret2] : ( 'operation' temp= identifier LPAREN ( (temp= parameter ( ( ( COMA ) temp= parameter ) )* ) )? RPAREN ( ( COLON temp= identifier ) | () ) SEMI ) ;
    public final Object operation() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Operation", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:2: ( ( 'operation' temp= identifier LPAREN ( (temp= parameter ( ( ( COMA ) temp= parameter ) )* ) )? RPAREN ( ( COLON temp= identifier ) | () ) SEMI ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:4: ( 'operation' temp= identifier LPAREN ( (temp= parameter ( ( ( COMA ) temp= parameter ) )* ) )? RPAREN ( ( COLON temp= identifier ) | () ) SEMI )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:4: ( 'operation' temp= identifier LPAREN ( (temp= parameter ( ( ( COMA ) temp= parameter ) )* ) )? RPAREN ( ( COLON temp= identifier ) | () ) SEMI )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:5: 'operation' temp= identifier LPAREN ( (temp= parameter ( ( ( COMA ) temp= parameter ) )* ) )? RPAREN ( ( COLON temp= identifier ) | () ) SEMI
            {
            match(input,53,FOLLOW_53_in_operation814); 
            pushFollow(FOLLOW_identifier_in_operation818);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            match(input,LPAREN,FOLLOW_LPAREN_in_operation822); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:69: ( (temp= parameter ( ( ( COMA ) temp= parameter ) )* ) )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==NAME) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:70: (temp= parameter ( ( ( COMA ) temp= parameter ) )* )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:70: (temp= parameter ( ( ( COMA ) temp= parameter ) )* )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:71: temp= parameter ( ( ( COMA ) temp= parameter ) )*
                    {
                    pushFollow(FOLLOW_parameter_in_operation828);
                    temp=parameter();
                    _fsp--;

                    ei.set(ret, "parameters", temp);
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:121: ( ( ( COMA ) temp= parameter ) )*
                    loop22:
                    do {
                        int alt22=2;
                        int LA22_0 = input.LA(1);

                        if ( (LA22_0==COMA) ) {
                            alt22=1;
                        }


                        switch (alt22) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:122: ( ( COMA ) temp= parameter )
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:122: ( ( COMA ) temp= parameter )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:123: ( COMA ) temp= parameter
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:123: ( COMA )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:124: COMA
                    	    {
                    	    match(input,COMA,FOLLOW_COMA_in_operation835); 

                    	    }

                    	    pushFollow(FOLLOW_parameter_in_operation840);
                    	    temp=parameter();
                    	    _fsp--;

                    	    ei.set(ret, "parameters", temp);

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop22;
                        }
                    } while (true);


                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_operation850); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:193: ( ( COLON temp= identifier ) | () )
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==COLON) ) {
                alt24=1;
            }
            else if ( (LA24_0==SEMI) ) {
                alt24=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("186:193: ( ( COLON temp= identifier ) | () )", 24, 0, input);

                throw nvae;
            }
            switch (alt24) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:194: ( COLON temp= identifier )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:194: ( COLON temp= identifier )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:195: COLON temp= identifier
                    {
                    match(input,COLON,FOLLOW_COLON_in_operation854); 
                    pushFollow(FOLLOW_identifier_in_operation858);
                    temp=identifier();
                    _fsp--;

                    ei.setRef(ret, "type", "Classifier", "name", temp, null, "never", null, false, null);

                    }



                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:310: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:310: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:186:311: 
                    {
                    }



                    }
                    break;

            }

            match(input,SEMI,FOLLOW_SEMI_in_operation872); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end operation


    // $ANTLR start parameter
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:196:1: parameter returns [Object ret2] : (temp= identifier COLON temp= identifier ) ;
    public final Object parameter() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Parameter", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:197:2: ( (temp= identifier COLON temp= identifier ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:197:4: (temp= identifier COLON temp= identifier )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:197:4: (temp= identifier COLON temp= identifier )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:197:5: temp= identifier COLON temp= identifier
            {
            pushFollow(FOLLOW_identifier_in_parameter906);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            match(input,COLON,FOLLOW_COLON_in_parameter910); 
            pushFollow(FOLLOW_identifier_in_parameter914);
            temp=identifier();
            _fsp--;

            ei.setRef(ret, "type", "Classifier", "name", temp, null, "never", null, false, null);

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end parameter


    // $ANTLR start enumeration
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:207:1: enumeration returns [Object ret2] : ( 'enumeration' temp= identifier LCURLY ( ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? ) ) RCURLY ) ;
    public final Object enumeration() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("Enumeration", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:2: ( ( 'enumeration' temp= identifier LCURLY ( ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? ) ) RCURLY ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:4: ( 'enumeration' temp= identifier LCURLY ( ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? ) ) RCURLY )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:4: ( 'enumeration' temp= identifier LCURLY ( ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? ) ) RCURLY )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:5: 'enumeration' temp= identifier LCURLY ( ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? ) ) RCURLY
            {
            match(input,54,FOLLOW_54_in_enumeration948); 
            pushFollow(FOLLOW_identifier_in_enumeration952);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            match(input,LCURLY,FOLLOW_LCURLY_in_enumeration956); 
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:71: ( ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:72: ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:72: ( ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )? )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:73: ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )?
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:73: ( (temp= enumLiteral ( (temp= enumLiteral ) )* ) )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==55) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:74: (temp= enumLiteral ( (temp= enumLiteral ) )* )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:74: (temp= enumLiteral ( (temp= enumLiteral ) )* )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:75: temp= enumLiteral ( (temp= enumLiteral ) )*
                    {
                    pushFollow(FOLLOW_enumLiteral_in_enumeration964);
                    temp=enumLiteral();
                    _fsp--;

                    ei.set(ret, "literals", temp);
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:125: ( (temp= enumLiteral ) )*
                    loop25:
                    do {
                        int alt25=2;
                        int LA25_0 = input.LA(1);

                        if ( (LA25_0==55) ) {
                            alt25=1;
                        }


                        switch (alt25) {
                    	case 1 :
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:126: (temp= enumLiteral )
                    	    {
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:126: (temp= enumLiteral )
                    	    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:208:127: temp= enumLiteral
                    	    {
                    	    pushFollow(FOLLOW_enumLiteral_in_enumeration972);
                    	    temp=enumLiteral();
                    	    _fsp--;

                    	    ei.set(ret, "literals", temp);

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop25;
                        }
                    } while (true);


                    }


                    }
                    break;

            }


            }


            }

            match(input,RCURLY,FOLLOW_RCURLY_in_enumeration984); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end enumeration


    // $ANTLR start enumLiteral
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:218:1: enumLiteral returns [Object ret2] : ( 'literal' temp= identifier SEMI ) ;
    public final Object enumLiteral() throws RecognitionException {
        Object ret2 = null;

        Object temp = null;


        Object ret=(backtracking==0) ? ei.create("EnumLiteral", false, false) : null;org.antlr.runtime.Token firstToken=input.LT(1);
        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:219:2: ( ( 'literal' temp= identifier SEMI ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:219:4: ( 'literal' temp= identifier SEMI )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:219:4: ( 'literal' temp= identifier SEMI )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:219:5: 'literal' temp= identifier SEMI
            {
            match(input,55,FOLLOW_55_in_enumLiteral1016); 
            pushFollow(FOLLOW_identifier_in_enumLiteral1020);
            temp=identifier();
            _fsp--;

            ei.set(ret, "name", temp);
            match(input,SEMI,FOLLOW_SEMI_in_enumLiteral1024); 

            }


                        ei.leaveContext(false);
                        if(input.LT(-1) != null) ei.setLocation(ret, firstToken.getLine() + ":" + (firstToken.getCharPositionInLine() + 1) + "-" + ((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndLine() + ":" + (((org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken)input.LT(-1)).getEndColumn() + 1));ei.setCommentsBefore(ret, new Object[] {input, firstToken});
            	   ei.setCommentsAfter(ret, new Object[] {input, input.LT(-1)});
                        ret2=ret;
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ret2;
    }
    // $ANTLR end enumLiteral


    // $ANTLR start multiplicity
    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:229:1: multiplicity[Object ret] : ( ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) ) ( ( 'ordered' ) | () ) ) ;
    public final void multiplicity(Object ret) throws RecognitionException {
        Object temp = null;


        try {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:2: ( ( ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) ) ( ( 'ordered' ) | () ) ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:4: ( ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) ) ( ( 'ordered' ) | () ) )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:4: ( ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) ) ( ( 'ordered' ) | () ) )
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:5: ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) ) ( ( 'ordered' ) | () )
            {
            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:5: ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) )
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==COLON||(LA29_0>=48 && LA29_0<=49)||LA29_0==52||LA29_0==56) ) {
                alt29=1;
            }
            else if ( (LA29_0==LSQUARE) ) {
                alt29=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("230:5: ( () | ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) ) )", 29, 0, input);

                throw nvae;
            }
            switch (alt29) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:6: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:6: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:7: 
                    {
                    }

                    ei.set(ret, "lower", new java.lang.Integer(1)); ei.set(ret, "upper", new java.lang.Integer(1));

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:108: ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:108: ( ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) ) )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:109: ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:109: ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) )
                    int alt28=2;
                    int LA28_0 = input.LA(1);

                    if ( (LA28_0==LSQUARE) ) {
                        int LA28_1 = input.LA(2);

                        if ( (LA28_1==STAR) ) {
                            alt28=1;
                        }
                        else if ( (LA28_1==INT) ) {
                            alt28=2;
                        }
                        else {
                            NoViableAltException nvae =
                                new NoViableAltException("230:109: ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) )", 28, 1, input);

                            throw nvae;
                        }
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("230:109: ( ( LSQUARE STAR RSQUARE ) | ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) ) )", 28, 0, input);

                        throw nvae;
                    }
                    switch (alt28) {
                        case 1 :
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:110: ( LSQUARE STAR RSQUARE )
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:110: ( LSQUARE STAR RSQUARE )
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:111: LSQUARE STAR RSQUARE
                            {
                            match(input,LSQUARE,FOLLOW_LSQUARE_in_multiplicity1064); 
                            match(input,STAR,FOLLOW_STAR_in_multiplicity1066); 
                            match(input,RSQUARE,FOLLOW_RSQUARE_in_multiplicity1068); 

                            }

                            ei.set(ret, "lower", new java.lang.Integer(0)); ei.set(ret, "upper", new java.lang.Integer(-1));

                            }
                            break;
                        case 2 :
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:233: ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) )
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:233: ( ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) ) )
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:234: ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) )
                            {
                            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:234: ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) )
                            int alt27=2;
                            int LA27_0 = input.LA(1);

                            if ( (LA27_0==LSQUARE) ) {
                                int LA27_1 = input.LA(2);

                                if ( (LA27_1==INT) ) {
                                    int LA27_2 = input.LA(3);

                                    if ( (LA27_2==MINUS) ) {
                                        int LA27_3 = input.LA(4);

                                        if ( (LA27_3==STAR) ) {
                                            alt27=1;
                                        }
                                        else if ( (LA27_3==INT) ) {
                                            alt27=2;
                                        }
                                        else {
                                            NoViableAltException nvae =
                                                new NoViableAltException("230:234: ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) )", 27, 3, input);

                                            throw nvae;
                                        }
                                    }
                                    else {
                                        NoViableAltException nvae =
                                            new NoViableAltException("230:234: ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) )", 27, 2, input);

                                        throw nvae;
                                    }
                                }
                                else {
                                    NoViableAltException nvae =
                                        new NoViableAltException("230:234: ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) )", 27, 1, input);

                                    throw nvae;
                                }
                            }
                            else {
                                NoViableAltException nvae =
                                    new NoViableAltException("230:234: ( ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE ) | ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE ) )", 27, 0, input);

                                throw nvae;
                            }
                            switch (alt27) {
                                case 1 :
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:235: ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE )
                                    {
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:235: ( LSQUARE temp= integerSymbol MINUS STAR RSQUARE )
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:236: LSQUARE temp= integerSymbol MINUS STAR RSQUARE
                                    {
                                    match(input,LSQUARE,FOLLOW_LSQUARE_in_multiplicity1077); 
                                    pushFollow(FOLLOW_integerSymbol_in_multiplicity1081);
                                    temp=integerSymbol();
                                    _fsp--;

                                    ei.set(ret, "lower", temp);
                                    match(input,MINUS,FOLLOW_MINUS_in_multiplicity1085); 
                                    match(input,STAR,FOLLOW_STAR_in_multiplicity1087); 
                                    match(input,RSQUARE,FOLLOW_RSQUARE_in_multiplicity1089); 

                                    }

                                    ei.set(ret, "upper", new java.lang.Integer(-1));

                                    }
                                    break;
                                case 2 :
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:365: ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE )
                                    {
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:365: ( LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE )
                                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:366: LSQUARE temp= integerSymbol MINUS temp= integerSymbol RSQUARE
                                    {
                                    match(input,LSQUARE,FOLLOW_LSQUARE_in_multiplicity1096); 
                                    pushFollow(FOLLOW_integerSymbol_in_multiplicity1100);
                                    temp=integerSymbol();
                                    _fsp--;

                                    ei.set(ret, "lower", temp);
                                    match(input,MINUS,FOLLOW_MINUS_in_multiplicity1104); 
                                    pushFollow(FOLLOW_integerSymbol_in_multiplicity1108);
                                    temp=integerSymbol();
                                    _fsp--;

                                    ei.set(ret, "upper", temp);
                                    match(input,RSQUARE,FOLLOW_RSQUARE_in_multiplicity1112); 

                                    }



                                    }
                                    break;

                            }


                            }



                            }
                            break;

                    }


                    }



                    }
                    break;

            }

            // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:501: ( ( 'ordered' ) | () )
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==56) ) {
                alt30=1;
            }
            else if ( (LA30_0==COLON||(LA30_0>=48 && LA30_0<=49)||LA30_0==52) ) {
                alt30=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("230:501: ( ( 'ordered' ) | () )", 30, 0, input);

                throw nvae;
            }
            switch (alt30) {
                case 1 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:502: ( 'ordered' )
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:502: ( 'ordered' )
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:503: 'ordered'
                    {
                    match(input,56,FOLLOW_56_in_multiplicity1128); 

                    }

                    ei.set(ret, "isOrdered", java.lang.Boolean.TRUE);

                    }
                    break;
                case 2 :
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:567: ()
                    {
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:567: ()
                    // C:\\Documents and Settings\\mddfabro\\My Documents\\workspaces\\ganimede_runtime\\KM3-2005\\Syntax\\KM3_ANTLR3.g:230:568: 
                    {
                    }

                    ei.set(ret, "isOrdered", java.lang.Boolean.FALSE);

                    }
                    break;

            }


            }


                        
                    

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end multiplicity


 

    public static final BitSet FOLLOW_metamodel_in_main46 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_main49 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_identifier82 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_stringSymbol116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_integerSymbol150 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_package__in_metamodel189 = new BitSet(new long[]{0x0000040000000002L});
    public static final BitSet FOLLOW_package__in_metamodel197 = new BitSet(new long[]{0x0000040000000002L});
    public static final BitSet FOLLOW_classifier_in_modelElement242 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_package__in_modelElement247 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumLiteral_in_modelElement252 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_dataType_in_classifier288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_class__in_classifier293 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enumeration_in_classifier298 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_42_in_package_331 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_package_335 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_package_339 = new BitSet(new long[]{0x00C03C0000000100L});
    public static final BitSet FOLLOW_modelElement_in_package_347 = new BitSet(new long[]{0x00C03C0000000100L});
    public static final BitSet FOLLOW_modelElement_in_package_355 = new BitSet(new long[]{0x00C03C0000000100L});
    public static final BitSet FOLLOW_RCURLY_in_package_367 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_43_in_dataType399 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_dataType403 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_SEMI_in_dataType407 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_44_in_class_441 = new BitSet(new long[]{0x0000200000000000L});
    public static final BitSet FOLLOW_45_in_class_453 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_class_457 = new BitSet(new long[]{0x0000400000000080L});
    public static final BitSet FOLLOW_46_in_class_463 = new BitSet(new long[]{0x0000000000000090L});
    public static final BitSet FOLLOW_identifier_in_class_469 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_COMA_in_class_476 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_class_481 = new BitSet(new long[]{0x0000000000000480L});
    public static final BitSet FOLLOW_LCURLY_in_class_501 = new BitSet(new long[]{0x0028800000000100L});
    public static final BitSet FOLLOW_structuralFeature_in_class_509 = new BitSet(new long[]{0x0028800000000100L});
    public static final BitSet FOLLOW_structuralFeature_in_class_517 = new BitSet(new long[]{0x0028800000000100L});
    public static final BitSet FOLLOW_operation_in_class_531 = new BitSet(new long[]{0x0020000000000100L});
    public static final BitSet FOLLOW_operation_in_class_539 = new BitSet(new long[]{0x0020000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_class_551 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_reference_in_structuralFeature586 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attribute_in_structuralFeature591 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_47_in_reference624 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_reference628 = new BitSet(new long[]{0x0103000000004800L});
    public static final BitSet FOLLOW_multiplicity_in_reference632 = new BitSet(new long[]{0x0003000000000800L});
    public static final BitSet FOLLOW_48_in_reference637 = new BitSet(new long[]{0x0002000000000800L});
    public static final BitSet FOLLOW_49_in_reference651 = new BitSet(new long[]{0x0000000000000810L});
    public static final BitSet FOLLOW_identifier_in_reference657 = new BitSet(new long[]{0x0000000000000C00L});
    public static final BitSet FOLLOW_COMA_in_reference664 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_reference669 = new BitSet(new long[]{0x0000000000000C00L});
    public static final BitSet FOLLOW_COLON_in_reference689 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_reference693 = new BitSet(new long[]{0x0004000000000200L});
    public static final BitSet FOLLOW_50_in_reference699 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_reference703 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_SEMI_in_reference717 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_51_in_attribute749 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_attribute753 = new BitSet(new long[]{0x0110000000004800L});
    public static final BitSet FOLLOW_multiplicity_in_attribute757 = new BitSet(new long[]{0x0010000000000800L});
    public static final BitSet FOLLOW_52_in_attribute762 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_COLON_in_attribute774 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_attribute778 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_SEMI_in_attribute782 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_53_in_operation814 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_operation818 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_LPAREN_in_operation822 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_parameter_in_operation828 = new BitSet(new long[]{0x0000000000002400L});
    public static final BitSet FOLLOW_COMA_in_operation835 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_parameter_in_operation840 = new BitSet(new long[]{0x0000000000002400L});
    public static final BitSet FOLLOW_RPAREN_in_operation850 = new BitSet(new long[]{0x0000000000000A00L});
    public static final BitSet FOLLOW_COLON_in_operation854 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_operation858 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_SEMI_in_operation872 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_identifier_in_parameter906 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_COLON_in_parameter910 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_parameter914 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_54_in_enumeration948 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_enumeration952 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_enumeration956 = new BitSet(new long[]{0x0080000000000100L});
    public static final BitSet FOLLOW_enumLiteral_in_enumeration964 = new BitSet(new long[]{0x0080000000000100L});
    public static final BitSet FOLLOW_enumLiteral_in_enumeration972 = new BitSet(new long[]{0x0080000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_enumeration984 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_55_in_enumLiteral1016 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_identifier_in_enumLiteral1020 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_SEMI_in_enumLiteral1024 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LSQUARE_in_multiplicity1064 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_STAR_in_multiplicity1066 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_RSQUARE_in_multiplicity1068 = new BitSet(new long[]{0x0100000000000002L});
    public static final BitSet FOLLOW_LSQUARE_in_multiplicity1077 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_integerSymbol_in_multiplicity1081 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_MINUS_in_multiplicity1085 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_STAR_in_multiplicity1087 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_RSQUARE_in_multiplicity1089 = new BitSet(new long[]{0x0100000000000002L});
    public static final BitSet FOLLOW_LSQUARE_in_multiplicity1096 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_integerSymbol_in_multiplicity1100 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_MINUS_in_multiplicity1104 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_integerSymbol_in_multiplicity1108 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_RSQUARE_in_multiplicity1112 = new BitSet(new long[]{0x0100000000000002L});
    public static final BitSet FOLLOW_56_in_multiplicity1128 = new BitSet(new long[]{0x0000000000000002L});

}