/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *******************************************************************************/


package org.eclipse.gmt.weaver.editors.interfaces;

/**
 * This Interface is used to create the woven and weaving model trees. It is used to avoid
 * problem with the selection listeners when selecting elements in all panels.
 * @since AMW2006
 */

public interface ITreeViewerSelection {
	/**
	 * set to true if the selection listeners shoudl be called
	 * @param fireSelection
	 */
	public void fireSelections(boolean fireSelection);
}
