/*******************************************************************************
 * Copyright (c) 2006 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/
package org.eclipse.gmt.weaver.transformation.util;

/**
 * Class for constants of weawer plugin 
 * @author - Marcos Didonet Del Fabro (LINA Labs, INRIA team)<br>
 * @since 1.0 
 */
public class TransformationConstant {
	static final public int TRANSFORMATION_EXT = 5;
    static final public String TRANSFORMATION_ID = "org.eclipse.gmt.weaver.transformation.transformationID";    

    
    static final public String AMWModelHandler = "AMW";
	/**
	 * transformation type
	 */
	static final public String MATCHING_TRANSFORMATION = "matching";
	static final public String HOT_TRANSFORMATION = "hot";
	static final public String TRANSFORMATION_CONFIG = "transformation_config";
	
	static final public String EXTRA_BINDING = "extraBinding";
	
	
	static final public String BASE_TRANSFORMATION_TYPE = "Transformation";
	static final public String CONFIG_MODEL_FEATURE = "hasConfigurationModel";
	static final public String EXECUTE_TRANSFO_FEATURE = "selected";
	static final public String TRANSFO_NAME_FEATURE = "name";
	static final public String PARAM_TRANSFO_SUFFIX = "_p";
	
	
	
	
    
    
}
